/*********************************************************
*Copyright (C), 2017, Shanghai Eastsoft Microelectronics Co., Ltd.
*ļ:  i2cs.c
*  :  LuF
*  :  V1.0
*  :  2018/7/24
*  :  I2CӶ
          1.I2CSRIF־λ1I2CRWλΪ0ʱʾдӻӻݡӻݻʱ
            жϱ־λI2CRBIFλȡһνݻI2CRBI2CRBIF־λԶ㣬ʹע
            οоƬֲᡣ
          2.I2CSRIF־λλI2CRWλΪ1ʱʾӻӻݡI2CTBݻ
            ʱжϱ־λI2CTBIFλдݻI2CTBݻдI2CTBIF־λԶ
            㣬һֽڣݻδжϱ־λI2CTBIFλ
          3.ӻյSTOPźʱշݻԶ㣬λI2CRSTλλI2Cģ顣λ
            ³ʼI2Cģ顣
          4.дһݸӻٶݡӻյԭͷʽظ
*  ע:  ES7P202x
ѧϰʾʹãûֱôķջеκηΡ
**********************************************************/
#include <hic.h>

void RAMClear(void);

sbit I2C_restart;
unsigned char I2CRB_reg;
unsigned char I2CTB_reg;

/*********************************************************
: void Init_i2c(void)
  :  I2CSģʼ
ֵ: 
ֵ: 
ֵ:  
**********************************************************/
void Init_i2c(void)        
{
    CHIPPACK = 0x04;    //ѡSDASCLܽΪPC6PC7
    I2CRST = 1;
    while(I2CRST);
    I2CX16 = 0x00;      //ֹ˲
    I2CC = 0xE1;        //I2Cʹܣ©ACK
    I2CSA = 0x5A;       //ӻַ=0x5A
    I2CIE = 1;          //I2CͨѶжʹ
    I2CIEC = 0x43;			
    I2CIFC = 0x00;
}

/*********************************************************
: void main()
  : 
ֵ: 
ֵ: 
ֵ:  
**********************************************************/
void main(void)
{
    RAMClear();              //RAMȫ
    PC = 0x00;               //PC˿͵ƽ
    PCT = 0xFF;              //PC˿Ϊ   
    PCS = 0x00;              //PCΪI/O
    I2C_restart = 0;
    Init_i2c();
    GIE = 1;
    while(1)
    {
        ;
    }
}

/*********************************************************
: void isr(void) interrupt
  : жϷ
ֵ: 
ֵ: 
ֵ:  
**********************************************************/
void isr(void) interrupt
{
    if(I2CIF)
    {
        I2CIF = 0;

        if(I2CSRIE && I2CSRIF)              //յʼλ+ַƥ+Ӧλ
        {
            I2CSRIF = 0;                    //I2Cʼλ+ַƥ+Ӧλ־λ  
            if(I2CRW ==1 )                  //
            {
                I2CRBIE = 0;                //I2CжϽֹ
                I2CTBIE = 1;                //I2Cжʹ
                I2C_restart = 1;
            }
            else if(I2CRW == 0)             //д
            {
                I2CRBIE = 1;                //I2Cжʹ
                I2CTBIE = 0;                //I2CжϽֹ  
            } 
         }

        if(I2CRBIE && I2CRBIF)              //I2Cջн
        {
    
	        I2CRB_reg = I2CRB;              //ջӲжϱ־     
	    
        }
	    
	    if(I2CTBIE && I2CTBIF)              //I2Cͻδ־
        {
            if(I2C_restart)
            {
                I2CTB = I2CRB_reg;          //дԭͻ
                I2C_restart = 0;
             }
             else
             {
			     I2CTB_reg = ~I2CRB_reg;
                 I2CTB = I2CTB_reg;         //дͻ          
             }           
        }
        if(I2CNAIE && I2CNAIF)              //I2Cжʹ
        {
            I2CTBIE = 0;
            I2CNAIF = 0;
        }
        if(I2CSPIE && I2CSPIF)              //յλ
        {
            I2CSPIF = 0;                    //λжϱ־    
            I2CRST = 1;                     //I2Cģ鸴λʹ
            while(I2CRST);                  //I2Cģ鸴λ
            I2CC = 0xE1;                    //I2Cʹܣ©ACK
            I2CSRIE = 1;                    //ʹI2Cַƥж
            I2CSPIE = 1;                    //ʹI2Cж
		    I2CNAIE = 1;
        }
    }           
}

/*********************************************************
: void RAMClear(void)
  : ͨRAMӳ
ֵ: 
ֵ: 
ֵ:  
**********************************************************/
void RAMClear(void)
{
    __asm{              //ַ0x0000~0x03FF
        MOVI 0x00           
        MOVA IAAH
        MOVI 0x00           
        MOVA IAAL 
        CLR  IAD 
        INC  IAAL,1
        JBS  PSW,C
        GOTO $-3
        INC IAAH,1
        JBS IAAH,2
        GOTO $-6
    }
}
    

